/*
 * Mirai. Copyright (C) 2024 Vyn
 * This file is licensed under version 3 of the GNU General Public License (GPL-3.0-only)
 * The license can be found in the LICENSE file or at https://www.gnu.org/licenses/gpl-3.0.txt
 */

#ifndef MIRAI_TODOMD_H
#define MIRAI_TODOMD_H

#include "TaskItem.h"
#include "TasksFile.h"
#include <string>

namespace mirai
{

class TodoMdFormat
{
  public:
	static std::unique_ptr<TasksFile> readFile(const std::string &path);
	static void writeFile(TasksFile &tasks);

	static std::string TaskToString(const TaskItem &task);
	static TaskItemData StringToTask(const std::string &str, const std::string &date);

  private:
	static std::string fieldWithSpace(const std::string &field);
	static TaskItem parseLine(const std::string &line);
	static Tags extractTagsFromMetadata(std::string metadata);
};
} // namespace mirai

#endif
